<?
###############################################################################################
#	msession-test.php
#	This is a test page for msession functions.
#	most msession functions are used in this page with
#	the exception of msession_get_data, and msession_set_data
#	which are used implicitly with the PHP session
#	extension.
#
#	Copyright Mark L. Woodward (c) 2001,2002
#	Mohawk Software
###############################################################################################
#
# Integration with PHP sessions
# 
# Start the session system, this will connect to msession
# as configured in PHP.INI.
#
# Start sessions, this will set a cookie.
session_start();

# Get sesson ID created by the session module.
$sid = session_id();


###############################################################################################
#
# Will test the server.
#
msession_ping();

###############################################################################################
#
# Testing existence of session ID
#
# With automatic garbage collection, it is sometimes a good idea to 
# be able to recreate a session ID.
# It is best to make sure that cookie experation and session
# expiration are correct.
if(!msession_ctl($sid, "EXIST"))
{
	print "Creating new session, old one was flushed<br>\n";
	$force_new = TRUE;
	msession_create($sid);
}
###############################################################################################
#
# When a session is created
#
if(!$HTTP_COOKIE_VARS["PHPSESSID"] || $force_new)
{
	if(0) // One at a time
	{
		echo "Set Variable: " . msession_set($sid, 'time',time()) ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name1','test1') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name2','test2') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name3','test3') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name4','test4') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name5','test5') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name6','test6') ."<p>\n";
		echo "Set Variable: " . msession_set($sid, 'name7','test7') ."<p>\n";
	}
	else // All at once in an array
	{
		$setarray = array();
		$setarray['time']=time();
		$setarray['name1'] = 'test1';
		$setarray['name2'] = 'test2';
		$setarray['name3'] = 'test3';
		$setarray['name4'] = 'test4';
		$setarray['name5'] = 'test5';
		$setarray['name6'] = 'test6';
		$setarray['name7'] = 'test7';
		msession_set_array($sid, $setarray);
	}
}
###############################################################################################
#
# Misc variable/value operations.
#
# This makes a link between the variable $count and the
# session variable "count"
session_register("count");

$count++;

# Output some information.
echo "sid: " . $sid . "<br>\n";
echo "Session Count: " . $count . "<br>\n";

# Use msession_randstr() to produce a random string.
# A string of n characters of jibberish is returned.
echo "Random String: " . msession_randstr(32) . "<br>\n";

# This is a thread safe increment, unlike PHP's session, many web servers
# can be updating this variable and collisions are managed.
# (for this to work, older versions of msessiond must be started with "-g globals"
#  newer versions create it by default)
echo "Global Count: " . msession_inc(globals, "counter") . "<br>\n";
echo "Total active sessions: " . msession_count() . "<br>\n";

# Gets all the msession values in an array
$varray = msession_get_array($sid);
if(!$varray)
	echo "Get variable array: Failed<br>\n";
else
{
	$arraykeys = array_keys($varray);
	for($i=0; $arraykeys[$i]; $i++)
		echo "Key: " . $arraykeys[ $i ] ." = " .$varray[$arraykeys[$i]] ."<br>\n";
}
###############################################################################################
#
# Manage session characteristics
#
# msession has a control call which allows the programer to get some inforation
# about the session, and msessiond. 

$ctlarray = array('EXIST', 'TTL', 'AGE', 'TLA', 'CTIME', 'TOUCH', 'NOW') ;
 
for($i =0; $ctlarray[$i] != ""; $i++)
{
	$ctlret = msession_ctl($sid, $ctlarray[$i]);
	print "$ctlarray[$i] : $ctlret <br>\n"; 
}
