/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2002 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 

//// Disable/Enable specific operational characteristics //////

// MTSVR is a multithreaded multisocket library
// that facilitates fewer sockets for more threads.
// With this enabled, a small number of sockets 
// answer all the requests. With this disabled, a
// thread is allocated for each socket
#define ENABLE_MTSVR


// This allows function relay. A plugin is called prior to
// every function. This can affect performance in high capacity
// servers. Unless you need this functionality, it is best to
// leave it turned off.
// #define ENABLE_RELAY

/////////// Define default values //////////////////////////////
//
#define DEF_PORT	8086 		// Anyone got a better port?
#define	DEF_LIST	4		// Default number of listeners
#define	DEF_DEAD	3600 		// unused sessions last 1 hour
#define DEF_QUE		128		// backlog to socket listen()
#define	DEF_INTR	60		// cleanup every minute
#define	DEF_LOCK	30		// How long a lock can stay locked
#define DEF_EXP		60		// How long a persistent connection stays unused.
#define DEF_HASH	8209		// Default size of the hash table
#define DEF_MAXTH	256		// Default maximum threads. (Not used with MTSVR)
#define DEF_AUTOSAVE	0		// Default time to automatically save settings
#define DEF_VERBOSE	0		// Verbosity level
#define DEF_SESSTO	30		// Number of minutes before a session expires
#define DEF_GLOBALS	"globals"	// Default name of globals session
#define DEF_SERIALIZE	"/tmp/mses.dat"	// Default serialization string (file based)
#define DEF_SESSIONLEN	32		// default string length of a session
#define DEF_MAXFLUSH	2000		// Max number of flushed sessions at once
#define DEF_NAME 	"msession"	// Default name of the session module
#define DEF_FILEPATH	NULL

#define DEF_REQBLEN	512		// How long the default request buffer is.
#ifdef POSIX
#define DEF_PERSONALITY	"flexplug.so"
#endif
#ifdef WIN32
#define DEF_PERSONALITY	"flexplug.dll"
#endif


#define 	CFG_PORT	"PORT"
#define 	CFG_LIST	"LIST"
#define 	CFG_DEAD	"DEAD"
#define		CFG_QUE		"QUEUE"
#define		CFG_INTR	"INTERVAL"
#define		CFG_LOCK	"LOCK"
#define 	CFG_EXP		"EXPIRE_CONN"
#define		CFG_HASH	"HASHSIZE"
#define 	CFG_MAXTH	"MAXTHREADS"
#define		CFG_AUTOSAVE	"AUTOSAVE"
#define		CFG_VERBOSE	"VERBOSE"
#define		CFG_SESSIONLEN	"SESSONLEN"


#define		CFG_SERIALIZE	"SERIALIZE"
#define 	CFG_GLOBALS	"GLOBALS"
#define		CFG_NAME	"NAME"
#define 	CFG_FILEPATH	"FILEPATH"
#define 	CFG_PERSONALITY	"PERSONALIY"

#define		CFG_MAXFLUSH	"MAXFLUSH"
#define 	CFG_AUTODROP	"AUTODROP"
#define 	CFGF_PLUGIN	"PLUGIN_%d"
#define 	CFGF_HBA	"HBA_%d"
