/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2002 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 


#include "session.h"
#include "msessionapi.h"

char ** StringsToArray(int count, char *strings);

int main(int argc, char **argv)
{
	char **strings = NULL;
	InitPhoenix(argc, argv);

	if(argc != 2)
	{
		printf("usage: %s host\n", argv[0]);
		printf("Lists all the sessions and all their variables on an msesson server\n");
		exit(0);
	}
	int cbhost = strlen(argv[1])+1;
	char *host = (char *)alloca(cbhost);
	int port = HostPort(host, argv[1], 8086);

	MSCONN conn = msession_connect(host, port);

	if(conn->StatOK())
	{
		strings = msession_list(conn);
		if(strings)
		{

			for(int i=0; strings[i]; i++)
			{
				printf("[%s]\n", strings[i]);
				char **vars = msession_get_array(conn, strings[i]);
				if(vars)
				{
					for(int i=0; vars[i]; )
					{
						char *one = vars[i++];
						char *two = vars[i++];
						printf("%s=%s\n", one, two);
					}
					free(vars);
				}
				printf("\n");
			}
			free(strings);
		}
			
	}
	if(!strings)
		printf("Failure: %s\n", msession_errtext(conn));

	msession_disconnect(conn);
	return 0;
}
