/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2002 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 


#include "session.h"
#include "msessionapi.h"

char ** StringsToArray(int count, char *strings);

int main(int argc, char **argv)
{
	char **strings=NULL;

	if(argc < 3)
	{
		printf("usage: %s host sessioni varname [varval]\n", argv[0]);
		printf("Lists all the sessions with a variable named 'varname' and optionally set to varval\n");
		exit(0);
	}
	InitPhoenix(argc, argv);
	int cbhost = strlen(argv[1])+1;
	char *host = (char *)alloca(cbhost);
	int port = HostPort(host, argv[1], 8086);

	MSCONN conn = msession_connect(host, port);

	if(conn->StatOK())
	{
		if(argc == 3)
		{
			strings = msession_listvar(conn, argv[2]);
			if(strings)
			{
				for(int i=0; strings[i]; )
				{
					char *one = strings[i++];
					char *two = strings[i++];
					printf("%s=%s\n", one, two);
				}
			}
		}
		else
		{
			strings = msession_find(conn, argv[2], argv[3]);
			if(strings)
			{
				for(int i=0; strings[i]; i++)
					printf("Session: %s\n", strings[i]);
			}
		}
	}
	if(!strings)
		printf("Failure: %s\n", msession_errtext(conn));
	msession_disconnect(conn);
	return 0;
}
