/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2002 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 

#define COUNT	50000

#include "session.h"
#include "msessionapi.h"

#define ONCE	0
#define VERBOSE	0

char *vars[]=
{
"test1", "fubar1",
"test2", "fubar2",
"test3", "fubar3",
"test4", "fubar4",
"test5", "fubar5",
"test6", "fubar6",
"test7", "fubar7",
"test1", "fubar7",
"test2", "fubar7",
"test3", "fubar7",
"test4", "fubar7",
"test5", "fubar7",
"test6", "fubar7",
"test7", "fubar7",
"test8", "fubar7",
"test9", "fubar7",
"testa", "fubar7",
"testb", "fubar7",
"testc", "fubar7",
"testd", "fubar7",
"teste", "fubar7",
"testf", "fubar7",
"testg", "fubar7",
"testh", "fubar7",
"testi", "fubar7",
NULL,NULL
};

void handleError(MSCONN conn, char *string)
{
	int err = msession_errno(conn);

	if(err != REQE_NOERROR)
	{
		fprintf(stderr, "%s [%d] %s\n", string, err, msession_errtext(conn));
		exit(0);
	}
}
int main(int argc, char **argv)
{
	time_t start = time(0);
	InitPhoenix(argc, argv);
	int cbhost = strlen(argv[1])+1;
	char *host = (char *)alloca(cbhost);
	int port = HostPort(host, argv[1], 8086);

	int count=0;
	do
	{
		char **array;
		char *p;
		MSCONN conn;
		int n;
		
		count++;

		conn = msession_connect(host,port);

		if(conn == NULL)
		{
			fprintf(stderr, "Count not connect\n");
			exit(0);
		}

		if(!msession_create_pairs(conn, argv[2], 7, vars))
		{
			if(msession_errno(conn) != REQE_DUPSESSION)
				handleError(conn, "msession_create_pairs");
		}

		int key = msession_lock(conn, argv[2]);

		handleError(conn,"Lock Session");

		int failed_key = msession_lock(conn, argv[2]);

		if(failed_key)
		{
			fprintf(stderr, "Locking of session should have failed\n");
			exit(0);
		}
#if VERBOSE
		printf("Key = %d\n", key);
#endif
		p = msession_get_text(conn, argv[2], "test1","");
		// handleError(conn,"msession_get_text");

		if(p)
		{
#if VERBOSE
			printf("Data: %s\n", p);
#endif
			free(p);
		}
#if VERBOSE
		else
			printf("No Data!!!\n");
#endif
		array = msession_get_array(conn, argv[2]);

		handleError(conn,"msession_getall");
		if(array)
		{
#if VERBOSE
			int i;
			for(i=0;array[i];i+=2)
			{
				char *name = array[i];
				char *value = array[i+1];
	
				if(!name || !value)
				{
					printf("Error in return %X %X\n", name, value);
					exit(0);
				}
				printf("%s = %s\n", name, value);
			}
#endif
			free(array);
		}
		
		n = msession_count(conn);
		handleError(conn,"msession_count");

#if VERBOSE
		printf("%d Sessions\n", n);
#endif
		msession_unlock(conn, argv[2], key);
		handleError(conn,"msession_unlock");

		char **a = msession_find(conn, "test1", "fubar1");
		handleError(conn,"msession_find");

#if VERBOSE
		printf("I'm here\n");

		for(int x=0; a[x]; x++)
			printf("%s\n", a[x]);
		fflush(stdout);
#endif

		msession_destroy(conn, argv[2]);
		handleError(conn,"msession_destroy");

		msession_disconnect(conn);
		handleError(conn,"msession_disconnect");
	}
#if ONCE
	while(0);
#else
	while(count < COUNT);

	time_t end = time(0);

	int cps = COUNT/(end-start);
	printf("connections per second %d\n", cps);
	// A count of msession calls less the connect and disconnect.
	printf("operations per second %d\n", cps*8); 
#endif
	return 0;
}
