/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2002 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to professionally license this library, the author
    can be reached at info@mohawksoft.com
*/ 

#define COUNT 5000

#include "session.h"
#include "msessionapi.h"

#define ONCE	0
#define VERBOSE	0

char *vars[]=
{
"test1", "fubar1",
"test2", "fubar2",
"test3", "fubar3",
"test4", "fubar4",
"test5", "fubar5",
"test6", "fubar6",
"test7", "fubar7",
"test1", "fubar7",
"test2", "fubar7",
"test3", "fubar7",
"test4", "fubar7",
"test5", "fubar7",
"test6", "fubar7",
"test7", "fubar7",
"test8", "fubar7",
"test9", "fubar7",
"testa", "fubar7",
"testb", "fubar7",
"testc", "fubar7",
"testd", "fubar7",
"teste", "fubar7",
"testf", "fubar7",
"testg", "fubar7",
"testh", "fubar7",
"testi", "fubar7",
NULL,NULL
};

void handleError(MSCONN conn, char *string)
{
	int err = msession_errno(conn);

	if(err != REQE_NOERROR)
	{
		fprintf(stderr, "%s [%d] %s\n", string, err, msession_errtext(conn));
		exit(0);
	}
}

FILE *createstatic(char *fname)
{
	FILE *file = fopen(fname, "w");
	assert(file);

	for(int i=0; i < 128; i++)
	{
		fputc( (rand() % 26)+'A', file);
	}

	fflush(file);
	return file;
}

char *getstatic()
{
	char fname[]="test.dat";
	FILE *file = fopen(fname,"r");

	if(!file)
		file = createstatic(fname);

	assert(file);

	fseek(file, 0, SEEK_END);
	long flen = ftell(file);
	fseek(file, 0, SEEK_SET);

	char *data = (char*)malloc(flen);

	assert(data);

	fread(data,1,flen, file);
	return data;
}

int main(int argc, char **argv)
{
	time_t start = time(0);
	time_t stop;

	int stopcount = (argc > 2) ? atoi(argv[2]) : COUNT;
	int count=0;
	InitPhoenix(argc, argv);
	int cbhost = strlen(argv[1])+1;
	char *host = (char *)alloca(cbhost);
	int port = HostPort(host, argv[1], 8086);

	while(start == time(0))
		;

	stop = start = time(0);

	char *session=NULL;

	char *phpdata = getstatic();

	do
	{
		MSCONN conn = msession_connect(host,port);

		if(conn == NULL)
		{
			fprintf(stderr, "Could not connect\n");
			exit(0);
		}

		if(!session)
			session = msession_uniq(conn,32);

		char * data = msession_getdata(conn,session);

		if(!data)
			data = strdup(phpdata);

		if(strcmp(data,phpdata))
		{
			printf("%s != %s\n", data, phpdata);
			assert(strcmp(data, phpdata)==0);
		}
				
		msession_setdata(conn, session, data);
#if 1
		msession_inc_int(conn, "globals", "count");
#endif
		free(data);

		count++;

		if((rand() %13 ) > 11)
		{
			msession_destroy(conn, session);
			free(session);
			session = NULL;
		}


		msession_disconnect(conn);
		handleError(conn,"msession_disconnect");

		if(count == stopcount)
			stop = time(0);
		else if(count > stopcount)
		{
			if(stop != time(0))
				break;	
		}

			
	}
	while(1);

	stop = time(0);

	int cps = count/(stop-start);
	printf("connections per second %d\n", cps);
	return 0;
}
